<?php

/*
 * http://phpxref.ftwr.co.uk/wordpress/nav.html?_functions/index.html
 */

function rax_get_plugin_data( $plugin_file) {
      $default_headers = array(
      'Name' => 'Plugin Name',
      'PluginURI' => 'Plugin URI',
      'Version' => 'Version',
      'Description' => 'Description',
      'Author' => 'Author',
      'AuthorURI' => 'Author URI',
      'TextDomain' => 'Text Domain',
      'DomainPath' => 'Domain Path',
      'Network' => 'Network',
      '_sitewide' => 'Site wide'
  );

  $plugin_data = rax_get_file_data( $plugin_file, $default_headers);


  if ( ! $plugin_data['Network'] && $plugin_data['_sitewide'] ) {
      
      $plugin_data['Network'] = $plugin_data['_sitewide'];
  }
  $plugin_data['Network'] = ( 'true' == strtolower( $plugin_data['Network'] ) );
  unset( $plugin_data['_sitewide'] );

  $plugin_data['Title']      = $plugin_data['Name'];
  $plugin_data['AuthorName'] = $plugin_data['Author'];
    

    return $plugin_data;
}

function search_replace($plugin,$search_term,$replace_term){
	$files = get_all_files(WP_T_R_UPLOAD_DIR.$plugin,".php");
	foreach($files as $key=> $file)
		file_put_contents($file, str_replace($search_term, $replace_term, file_get_contents($file)));
		
	
	$files = get_all_files(WP_T_R_UPLOAD_DIR.$plugin,".txt");
	foreach($files as $key=> $file)
		file_put_contents($file, str_replace($search_term, $replace_term, file_get_contents($file)));	
	
	$files = get_all_files(WP_T_R_UPLOAD_DIR.$plugin,".css");
	foreach($files as $key=> $file)
		file_put_contents($file, str_replace($search_term, $replace_term, file_get_contents($file)));	
		
	$files = get_all_files(WP_T_R_UPLOAD_DIR.$plugin,".xml");
	foreach($files as $key=> $file)
		file_put_contents($file, str_replace($search_term, $replace_term, file_get_contents($file)));	
	
	$files = get_all_files(WP_T_R_UPLOAD_DIR.$plugin,".po");
	foreach($files as $key=> $file)
		file_put_contents($file, str_replace($search_term, $replace_term, file_get_contents($file)));	

}


function get_object_page_slug($plugin)
{
	$fromFile="";
	$files = get_all_files(WP_P_R_UPLOAD_DIR.$plugin,".php");
	
	foreach ($files as $key => $file) {
		$regex = "/add_object_page\(([^,]*),([^,]*),([^,]*),([^,]*),(.*);/";
		
		$filecontent = file_get_contents($file);
		preg_match($regex, $filecontent,$matches);
		if(!empty($matches))
		{
			$fromFile = $file;
			break;
		}
	}
	if(empty($matches)){
		foreach ($files as $key => $file) {
			$regex = "/add_menu_page\(([^,]*),([^,]*),([^,]*),([^,]*),(.*);/";
			
			$filecontent = file_get_contents($file);
			preg_match($regex, $filecontent,$matches);
			if(!empty($matches))
			{
				$fromFile = $file;
				break;
			}
		}
	}
	
	if(!empty($matches))
	{

		$matched_text = str_replace("'", "\"", trim($matches[4]));
 
		return array($fromFile,$matched_text ); 
	}	
	else
		return FALSE;
}

function get_all_files($start_dir='',$extension="") {

  $files = array();
  if (is_dir($start_dir)) {
    $fh = @opendir($start_dir);
    while (($file = @readdir($fh)) !== false) {
      # loop through the files, skipping . and .., and recursing if necessary
      if (substr($file, 0, 1) == '.') continue; 
      $filepath = $start_dir . '/' . $file;
      if ( is_dir($filepath) )
        $files = array_merge($files, get_all_files($filepath,$extension));
      else{
      	if($extension!="")
      	{
      		if(substr($filepath,'-'.strlen($extension))==$extension)
      			array_push($files, $filepath);
      	}
		else
			array_push($files, $filepath);
		
      }
        
    }
    closedir($fh);
  } else {
    # false if the function was called with an invalid non-directory argument
    $files = false;
  }

  return $files;

}

function rax_get_file_data( $file, $all_headers) {
	// We don't need to write to the file, so just open for reading.
	$fp = fopen( $file, 'r' );

	// Pull only the first 8kiB of the file in.
	$file_data = fread( $fp,8192 );

	// PHP will close file handle, but we are good citizens.
	fclose( $fp );

	foreach ( $all_headers as $field => $regex ) {
		
		preg_match( '/^[ \t\/*#@]*' . preg_quote( $regex, '/' ) . ':(.*)$/mi', $file_data, ${$field});
		if ( !empty( ${$field} ) )
			${$field} = trim(preg_replace("/\s*(?:\*\/|\?>).*/", '', ${$field}[1]));
		else
			${$field} = '';
		
	}
	
	$file_data = compact( array_keys( $all_headers ) );

	return $file_data;
}




/**
 * Get a list of a plugin's files.
 *
 * @since 2.8.0
 *
 * @param string $plugin Plugin ID
 * @return array List of files relative to the plugin root.
 */
function rax_get_plugin_files($plugin) {
	
    $plugin_file = WP_P_R_UPLOAD_DIR. $plugin;
    $dir = dirname($plugin_file);
    $plugin_files = array($plugin);
    if ( is_dir($dir) && $dir != WP_P_R_UPLOAD_DIR_NAME ) {
        $plugins_dir = @ opendir( $dir );
        if ( $plugins_dir ) {
            while (($file = readdir( $plugins_dir ) ) !== false ) {
                if ( substr($file, 0, 1) == '.' )
                    continue;
                if ( is_dir( $dir . '/' . $file ) ) {
                    $plugins_subdir = @ opendir( $dir . '/' . $file );
                    if ( $plugins_subdir ) {
                        while (($subfile = readdir( $plugins_subdir ) ) !== false ) {
                            if ( substr($subfile, 0, 1) == '.' )
                                continue;
                            $plugin_files[] = rax_plugin_basename("$dir/$file/$subfile");
                        }
                        @closedir( $plugins_subdir );
                    }
                } else {
                    if ( rax_plugin_basename("$dir/$file") != $plugin )
                        $plugin_files[] = rax_plugin_basename("$dir/$file");
                }
            }
            @closedir( $plugins_dir );
        }
    }

    return $plugin_files;
}

/**
 * Check the plugins directory and retrieve all plugin files with plugin data.
 *
 * WordPress only supports plugin files in the base plugins directory
 * (wp-content/plugins) and in one directory above the plugins directory
 * (wp-content/plugins/my-plugin). The file it looks for has the plugin data and
 * must be found in those two locations. It is recommended that do keep your
 * plugin files in directories.
 *
 * The file with the plugin data is the file that will be included and therefore
 * needs to have the main execution for the plugin. This does not mean
 * everything must be contained in the file and it is recommended that the file
 * be split for maintainability. Keep everything in one file for extreme
 * optimization purposes.
 *
 * @since 1.5.0
 *
 * @param string $plugin_folder Optional. Relative path to single plugin folder.
 * @return array Key is the plugin file path and the value is an array of the plugin data.
 */
function rax_get_plugins($plugin_folder = '') {

    
    $wp_plugins = array ();
    $plugin_root = WP_P_R_UPLOAD_DIR;
    if ( !empty($plugin_folder) )
        $plugin_root .= $plugin_folder;

    // Files in wp-content/plugins directory
    $plugins_dir = @ opendir( $plugin_root);
    $plugin_files = array();
    if ( $plugins_dir ) {
        while (($file = readdir( $plugins_dir ) ) !== false ) {
            if ( substr($file, 0, 1) == '.' )
                continue;
            if ( is_dir( $plugin_root.'/'.$file ) ) {
                $plugins_subdir = @ opendir( $plugin_root.'/'.$file );
                if ( $plugins_subdir ) {
                    while (($subfile = readdir( $plugins_subdir ) ) !== false ) {
                        if ( substr($subfile, 0, 1) == '.' )
                            continue;
                        if ( substr($subfile, -4) == '.php' )
                            $plugin_files[] = "$file/$subfile";
                    }
                    closedir( $plugins_subdir );
                }
            } else {
                if ( substr($file, -4) == '.php' )
                    $plugin_files[] = $file;
            }
        }
        closedir( $plugins_dir );
    }

    if ( empty($plugin_files) )
        return $wp_plugins;
    foreach ( $plugin_files as $plugin_file ) {
        if ( !is_readable( "$plugin_root/$plugin_file" ) )
            continue;

        $plugin_data = rax_get_plugin_data( "$plugin_root/$plugin_file"); //Do not apply markup/translate as it'll be cached.		
        if ( empty ( $plugin_data['Name'] ) )
            continue;

        $wp_plugins[rax_plugin_basename( $plugin_file )] = $plugin_data;
		
    }

    // uasort( $wp_plugins, '_sort_uname_callback' );

    

    return $wp_plugins;
}
   /**
   * Gets the basename of a plugin.
   *
   * This method extracts the name of a plugin from its filename.
   *
   * @package WordPress
   * @subpackage Plugin
   * @since 1.5
   *
   * @access private
   *
   * @param string $file The filename of plugin.
   * @return string The name of a plugin.
   * @uses WP_PLUGIN_DIR
   */
  function rax_plugin_basename($file) {
      $file = str_replace('\\','/',$file); // sanitize for Win32 installs
      $file = preg_replace('|/+|','/', $file); // remove any duplicate slash
      $plugin_dir = str_replace('\\','/',WP_P_R_UPLOAD_DIR_NAME); // sanitize for Win32 installs
      $plugin_dir = preg_replace('|/+|','/', $plugin_dir); // remove any duplicate slash
      $mu_plugin_dir = str_replace('\\','/',WP_P_R_UPLOAD_DIR_NAME); // sanitize for Win32 installs
      $mu_plugin_dir = preg_replace('|/+|','/', $mu_plugin_dir); // remove any duplicate slash
      $file = preg_replace('#^' . preg_quote($plugin_dir, '#') . '/|^' . preg_quote($mu_plugin_dir, '#') . '/#','',$file); // get relative path from plugins dir
      $file = trim($file, '/');
      return $file;
  }

?>